/*
 * Copyright 2014 CyberVision, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Autogenerated by Avro
 * 
 * DO NOT EDIT DIRECTLY
 */
package org.kaaproject.kaa.common.endpoint.gen;  
@SuppressWarnings("all")
@org.apache.avro.specific.AvroGenerated
public class SyncRequest extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"SyncRequest\",\"namespace\":\"org.kaaproject.kaa.common.endpoint.gen\",\"fields\":[{\"name\":\"applicationToken\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"endpointPublicKeyHash\",\"type\":\"bytes\"},{\"name\":\"profileHash\",\"type\":\"bytes\"},{\"name\":\"configurationHash\",\"type\":\"bytes\"},{\"name\":\"topicListHash\",\"type\":\"bytes\"},{\"name\":\"appStateSeqNumber\",\"type\":\"int\"},{\"name\":\"acceptedUnicastNotifications\",\"type\":[{\"type\":\"array\",\"items\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},\"null\"]},{\"name\":\"topicStates\",\"type\":[{\"type\":\"array\",\"items\":{\"type\":\"record\",\"name\":\"TopicState\",\"fields\":[{\"name\":\"topicId\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"seqNumber\",\"type\":\"int\"}]}},\"null\"]},{\"name\":\"subscriptionCommands\",\"type\":[{\"type\":\"array\",\"items\":{\"type\":\"record\",\"name\":\"SubscriptionCommand\",\"fields\":[{\"name\":\"topicId\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"command\",\"type\":{\"type\":\"enum\",\"name\":\"SubscriptionCommandType\",\"symbols\":[\"ADD\",\"REMOVE\"]}}]}},\"null\"]}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }
   private java.lang.String applicationToken;
   private java.nio.ByteBuffer endpointPublicKeyHash;
   private java.nio.ByteBuffer profileHash;
   private java.nio.ByteBuffer configurationHash;
   private java.nio.ByteBuffer topicListHash;
   private int appStateSeqNumber;
   private java.util.List<java.lang.String> acceptedUnicastNotifications;
   private java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> topicStates;
   private java.util.List<org.kaaproject.kaa.common.endpoint.gen.SubscriptionCommand> subscriptionCommands;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use {@link \#newBuilder()}. 
   */
  public SyncRequest() {}

  /**
   * All-args constructor.
   */
  public SyncRequest(java.lang.String applicationToken, java.nio.ByteBuffer endpointPublicKeyHash, java.nio.ByteBuffer profileHash, java.nio.ByteBuffer configurationHash, java.nio.ByteBuffer topicListHash, java.lang.Integer appStateSeqNumber, java.util.List<java.lang.String> acceptedUnicastNotifications, java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> topicStates, java.util.List<org.kaaproject.kaa.common.endpoint.gen.SubscriptionCommand> subscriptionCommands) {
    this.applicationToken = applicationToken;
    this.endpointPublicKeyHash = endpointPublicKeyHash;
    this.profileHash = profileHash;
    this.configurationHash = configurationHash;
    this.topicListHash = topicListHash;
    this.appStateSeqNumber = appStateSeqNumber;
    this.acceptedUnicastNotifications = acceptedUnicastNotifications;
    this.topicStates = topicStates;
    this.subscriptionCommands = subscriptionCommands;
  }

  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call. 
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return applicationToken;
    case 1: return endpointPublicKeyHash;
    case 2: return profileHash;
    case 3: return configurationHash;
    case 4: return topicListHash;
    case 5: return appStateSeqNumber;
    case 6: return acceptedUnicastNotifications;
    case 7: return topicStates;
    case 8: return subscriptionCommands;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }
  // Used by DatumReader.  Applications should not call. 
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: applicationToken = (java.lang.String)value$; break;
    case 1: endpointPublicKeyHash = (java.nio.ByteBuffer)value$; break;
    case 2: profileHash = (java.nio.ByteBuffer)value$; break;
    case 3: configurationHash = (java.nio.ByteBuffer)value$; break;
    case 4: topicListHash = (java.nio.ByteBuffer)value$; break;
    case 5: appStateSeqNumber = (java.lang.Integer)value$; break;
    case 6: acceptedUnicastNotifications = (java.util.List<java.lang.String>)value$; break;
    case 7: topicStates = (java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState>)value$; break;
    case 8: subscriptionCommands = (java.util.List<org.kaaproject.kaa.common.endpoint.gen.SubscriptionCommand>)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'applicationToken' field.
   */
  public java.lang.String getApplicationToken() {
    return applicationToken;
  }

  /**
   * Sets the value of the 'applicationToken' field.
   * @param value the value to set.
   */
  public void setApplicationToken(java.lang.String value) {
    this.applicationToken = value;
  }

  /**
   * Gets the value of the 'endpointPublicKeyHash' field.
   */
  public java.nio.ByteBuffer getEndpointPublicKeyHash() {
    return endpointPublicKeyHash;
  }

  /**
   * Sets the value of the 'endpointPublicKeyHash' field.
   * @param value the value to set.
   */
  public void setEndpointPublicKeyHash(java.nio.ByteBuffer value) {
    this.endpointPublicKeyHash = value;
  }

  /**
   * Gets the value of the 'profileHash' field.
   */
  public java.nio.ByteBuffer getProfileHash() {
    return profileHash;
  }

  /**
   * Sets the value of the 'profileHash' field.
   * @param value the value to set.
   */
  public void setProfileHash(java.nio.ByteBuffer value) {
    this.profileHash = value;
  }

  /**
   * Gets the value of the 'configurationHash' field.
   */
  public java.nio.ByteBuffer getConfigurationHash() {
    return configurationHash;
  }

  /**
   * Sets the value of the 'configurationHash' field.
   * @param value the value to set.
   */
  public void setConfigurationHash(java.nio.ByteBuffer value) {
    this.configurationHash = value;
  }

  /**
   * Gets the value of the 'topicListHash' field.
   */
  public java.nio.ByteBuffer getTopicListHash() {
    return topicListHash;
  }

  /**
   * Sets the value of the 'topicListHash' field.
   * @param value the value to set.
   */
  public void setTopicListHash(java.nio.ByteBuffer value) {
    this.topicListHash = value;
  }

  /**
   * Gets the value of the 'appStateSeqNumber' field.
   */
  public java.lang.Integer getAppStateSeqNumber() {
    return appStateSeqNumber;
  }

  /**
   * Sets the value of the 'appStateSeqNumber' field.
   * @param value the value to set.
   */
  public void setAppStateSeqNumber(java.lang.Integer value) {
    this.appStateSeqNumber = value;
  }

  /**
   * Gets the value of the 'acceptedUnicastNotifications' field.
   */
  public java.util.List<java.lang.String> getAcceptedUnicastNotifications() {
    return acceptedUnicastNotifications;
  }

  /**
   * Sets the value of the 'acceptedUnicastNotifications' field.
   * @param value the value to set.
   */
  public void setAcceptedUnicastNotifications(java.util.List<java.lang.String> value) {
    this.acceptedUnicastNotifications = value;
  }

  /**
   * Gets the value of the 'topicStates' field.
   */
  public java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> getTopicStates() {
    return topicStates;
  }

  /**
   * Sets the value of the 'topicStates' field.
   * @param value the value to set.
   */
  public void setTopicStates(java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> value) {
    this.topicStates = value;
  }

  /**
   * Gets the value of the 'subscriptionCommands' field.
   */
  public java.util.List<org.kaaproject.kaa.common.endpoint.gen.SubscriptionCommand> getSubscriptionCommands() {
    return subscriptionCommands;
  }

  /**
   * Sets the value of the 'subscriptionCommands' field.
   * @param value the value to set.
   */
  public void setSubscriptionCommands(java.util.List<org.kaaproject.kaa.common.endpoint.gen.SubscriptionCommand> value) {
    this.subscriptionCommands = value;
  }

  /** Creates a new SyncRequest RecordBuilder */
  public static org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder newBuilder() {
    return new org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder();
  }
  
  /** Creates a new SyncRequest RecordBuilder by copying an existing Builder */
  public static org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder newBuilder(org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder other) {
    return new org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder(other);
  }
  
  /** Creates a new SyncRequest RecordBuilder by copying an existing SyncRequest instance */
  public static org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder newBuilder(org.kaaproject.kaa.common.endpoint.gen.SyncRequest other) {
    return new org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder(other);
  }
  
  /**
   * RecordBuilder for SyncRequest instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<SyncRequest>
    implements org.apache.avro.data.RecordBuilder<SyncRequest> {

    private java.lang.String applicationToken;
    private java.nio.ByteBuffer endpointPublicKeyHash;
    private java.nio.ByteBuffer profileHash;
    private java.nio.ByteBuffer configurationHash;
    private java.nio.ByteBuffer topicListHash;
    private int appStateSeqNumber;
    private java.util.List<java.lang.String> acceptedUnicastNotifications;
    private java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> topicStates;
    private java.util.List<org.kaaproject.kaa.common.endpoint.gen.SubscriptionCommand> subscriptionCommands;

    /** Creates a new Builder */
    private Builder() {
      super(org.kaaproject.kaa.common.endpoint.gen.SyncRequest.SCHEMA$);
    }
    
    /** Creates a Builder by copying an existing Builder */
    private Builder(org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.applicationToken)) {
        this.applicationToken = data().deepCopy(fields()[0].schema(), other.applicationToken);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.endpointPublicKeyHash)) {
        this.endpointPublicKeyHash = data().deepCopy(fields()[1].schema(), other.endpointPublicKeyHash);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.profileHash)) {
        this.profileHash = data().deepCopy(fields()[2].schema(), other.profileHash);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.configurationHash)) {
        this.configurationHash = data().deepCopy(fields()[3].schema(), other.configurationHash);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.topicListHash)) {
        this.topicListHash = data().deepCopy(fields()[4].schema(), other.topicListHash);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.appStateSeqNumber)) {
        this.appStateSeqNumber = data().deepCopy(fields()[5].schema(), other.appStateSeqNumber);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.acceptedUnicastNotifications)) {
        this.acceptedUnicastNotifications = data().deepCopy(fields()[6].schema(), other.acceptedUnicastNotifications);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.topicStates)) {
        this.topicStates = data().deepCopy(fields()[7].schema(), other.topicStates);
        fieldSetFlags()[7] = true;
      }
      if (isValidValue(fields()[8], other.subscriptionCommands)) {
        this.subscriptionCommands = data().deepCopy(fields()[8].schema(), other.subscriptionCommands);
        fieldSetFlags()[8] = true;
      }
    }
    
    /** Creates a Builder by copying an existing SyncRequest instance */
    private Builder(org.kaaproject.kaa.common.endpoint.gen.SyncRequest other) {
            super(org.kaaproject.kaa.common.endpoint.gen.SyncRequest.SCHEMA$);
      if (isValidValue(fields()[0], other.applicationToken)) {
        this.applicationToken = data().deepCopy(fields()[0].schema(), other.applicationToken);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.endpointPublicKeyHash)) {
        this.endpointPublicKeyHash = data().deepCopy(fields()[1].schema(), other.endpointPublicKeyHash);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.profileHash)) {
        this.profileHash = data().deepCopy(fields()[2].schema(), other.profileHash);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.configurationHash)) {
        this.configurationHash = data().deepCopy(fields()[3].schema(), other.configurationHash);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.topicListHash)) {
        this.topicListHash = data().deepCopy(fields()[4].schema(), other.topicListHash);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.appStateSeqNumber)) {
        this.appStateSeqNumber = data().deepCopy(fields()[5].schema(), other.appStateSeqNumber);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.acceptedUnicastNotifications)) {
        this.acceptedUnicastNotifications = data().deepCopy(fields()[6].schema(), other.acceptedUnicastNotifications);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.topicStates)) {
        this.topicStates = data().deepCopy(fields()[7].schema(), other.topicStates);
        fieldSetFlags()[7] = true;
      }
      if (isValidValue(fields()[8], other.subscriptionCommands)) {
        this.subscriptionCommands = data().deepCopy(fields()[8].schema(), other.subscriptionCommands);
        fieldSetFlags()[8] = true;
      }
    }

    /** Gets the value of the 'applicationToken' field */
    public java.lang.String getApplicationToken() {
      return applicationToken;
    }
    
    /** Sets the value of the 'applicationToken' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder setApplicationToken(java.lang.String value) {
      validate(fields()[0], value);
      this.applicationToken = value;
      fieldSetFlags()[0] = true;
      return this; 
    }
    
    /** Checks whether the 'applicationToken' field has been set */
    public boolean hasApplicationToken() {
      return fieldSetFlags()[0];
    }
    
    /** Clears the value of the 'applicationToken' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder clearApplicationToken() {
      applicationToken = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /** Gets the value of the 'endpointPublicKeyHash' field */
    public java.nio.ByteBuffer getEndpointPublicKeyHash() {
      return endpointPublicKeyHash;
    }
    
    /** Sets the value of the 'endpointPublicKeyHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder setEndpointPublicKeyHash(java.nio.ByteBuffer value) {
      validate(fields()[1], value);
      this.endpointPublicKeyHash = value;
      fieldSetFlags()[1] = true;
      return this; 
    }
    
    /** Checks whether the 'endpointPublicKeyHash' field has been set */
    public boolean hasEndpointPublicKeyHash() {
      return fieldSetFlags()[1];
    }
    
    /** Clears the value of the 'endpointPublicKeyHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder clearEndpointPublicKeyHash() {
      endpointPublicKeyHash = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /** Gets the value of the 'profileHash' field */
    public java.nio.ByteBuffer getProfileHash() {
      return profileHash;
    }
    
    /** Sets the value of the 'profileHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder setProfileHash(java.nio.ByteBuffer value) {
      validate(fields()[2], value);
      this.profileHash = value;
      fieldSetFlags()[2] = true;
      return this; 
    }
    
    /** Checks whether the 'profileHash' field has been set */
    public boolean hasProfileHash() {
      return fieldSetFlags()[2];
    }
    
    /** Clears the value of the 'profileHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder clearProfileHash() {
      profileHash = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /** Gets the value of the 'configurationHash' field */
    public java.nio.ByteBuffer getConfigurationHash() {
      return configurationHash;
    }
    
    /** Sets the value of the 'configurationHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder setConfigurationHash(java.nio.ByteBuffer value) {
      validate(fields()[3], value);
      this.configurationHash = value;
      fieldSetFlags()[3] = true;
      return this; 
    }
    
    /** Checks whether the 'configurationHash' field has been set */
    public boolean hasConfigurationHash() {
      return fieldSetFlags()[3];
    }
    
    /** Clears the value of the 'configurationHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder clearConfigurationHash() {
      configurationHash = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /** Gets the value of the 'topicListHash' field */
    public java.nio.ByteBuffer getTopicListHash() {
      return topicListHash;
    }
    
    /** Sets the value of the 'topicListHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder setTopicListHash(java.nio.ByteBuffer value) {
      validate(fields()[4], value);
      this.topicListHash = value;
      fieldSetFlags()[4] = true;
      return this; 
    }
    
    /** Checks whether the 'topicListHash' field has been set */
    public boolean hasTopicListHash() {
      return fieldSetFlags()[4];
    }
    
    /** Clears the value of the 'topicListHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder clearTopicListHash() {
      topicListHash = null;
      fieldSetFlags()[4] = false;
      return this;
    }

    /** Gets the value of the 'appStateSeqNumber' field */
    public java.lang.Integer getAppStateSeqNumber() {
      return appStateSeqNumber;
    }
    
    /** Sets the value of the 'appStateSeqNumber' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder setAppStateSeqNumber(int value) {
      validate(fields()[5], value);
      this.appStateSeqNumber = value;
      fieldSetFlags()[5] = true;
      return this; 
    }
    
    /** Checks whether the 'appStateSeqNumber' field has been set */
    public boolean hasAppStateSeqNumber() {
      return fieldSetFlags()[5];
    }
    
    /** Clears the value of the 'appStateSeqNumber' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder clearAppStateSeqNumber() {
      fieldSetFlags()[5] = false;
      return this;
    }

    /** Gets the value of the 'acceptedUnicastNotifications' field */
    public java.util.List<java.lang.String> getAcceptedUnicastNotifications() {
      return acceptedUnicastNotifications;
    }
    
    /** Sets the value of the 'acceptedUnicastNotifications' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder setAcceptedUnicastNotifications(java.util.List<java.lang.String> value) {
      validate(fields()[6], value);
      this.acceptedUnicastNotifications = value;
      fieldSetFlags()[6] = true;
      return this; 
    }
    
    /** Checks whether the 'acceptedUnicastNotifications' field has been set */
    public boolean hasAcceptedUnicastNotifications() {
      return fieldSetFlags()[6];
    }
    
    /** Clears the value of the 'acceptedUnicastNotifications' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder clearAcceptedUnicastNotifications() {
      acceptedUnicastNotifications = null;
      fieldSetFlags()[6] = false;
      return this;
    }

    /** Gets the value of the 'topicStates' field */
    public java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> getTopicStates() {
      return topicStates;
    }
    
    /** Sets the value of the 'topicStates' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder setTopicStates(java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> value) {
      validate(fields()[7], value);
      this.topicStates = value;
      fieldSetFlags()[7] = true;
      return this; 
    }
    
    /** Checks whether the 'topicStates' field has been set */
    public boolean hasTopicStates() {
      return fieldSetFlags()[7];
    }
    
    /** Clears the value of the 'topicStates' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder clearTopicStates() {
      topicStates = null;
      fieldSetFlags()[7] = false;
      return this;
    }

    /** Gets the value of the 'subscriptionCommands' field */
    public java.util.List<org.kaaproject.kaa.common.endpoint.gen.SubscriptionCommand> getSubscriptionCommands() {
      return subscriptionCommands;
    }
    
    /** Sets the value of the 'subscriptionCommands' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder setSubscriptionCommands(java.util.List<org.kaaproject.kaa.common.endpoint.gen.SubscriptionCommand> value) {
      validate(fields()[8], value);
      this.subscriptionCommands = value;
      fieldSetFlags()[8] = true;
      return this; 
    }
    
    /** Checks whether the 'subscriptionCommands' field has been set */
    public boolean hasSubscriptionCommands() {
      return fieldSetFlags()[8];
    }
    
    /** Clears the value of the 'subscriptionCommands' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncRequest.Builder clearSubscriptionCommands() {
      subscriptionCommands = null;
      fieldSetFlags()[8] = false;
      return this;
    }

    @Override
    public SyncRequest build() {
      try {
        SyncRequest record = new SyncRequest();
        record.applicationToken = fieldSetFlags()[0] ? this.applicationToken : (java.lang.String) defaultValue(fields()[0]);
        record.endpointPublicKeyHash = fieldSetFlags()[1] ? this.endpointPublicKeyHash : (java.nio.ByteBuffer) defaultValue(fields()[1]);
        record.profileHash = fieldSetFlags()[2] ? this.profileHash : (java.nio.ByteBuffer) defaultValue(fields()[2]);
        record.configurationHash = fieldSetFlags()[3] ? this.configurationHash : (java.nio.ByteBuffer) defaultValue(fields()[3]);
        record.topicListHash = fieldSetFlags()[4] ? this.topicListHash : (java.nio.ByteBuffer) defaultValue(fields()[4]);
        record.appStateSeqNumber = fieldSetFlags()[5] ? this.appStateSeqNumber : (java.lang.Integer) defaultValue(fields()[5]);
        record.acceptedUnicastNotifications = fieldSetFlags()[6] ? this.acceptedUnicastNotifications : (java.util.List<java.lang.String>) defaultValue(fields()[6]);
        record.topicStates = fieldSetFlags()[7] ? this.topicStates : (java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState>) defaultValue(fields()[7]);
        record.subscriptionCommands = fieldSetFlags()[8] ? this.subscriptionCommands : (java.util.List<org.kaaproject.kaa.common.endpoint.gen.SubscriptionCommand>) defaultValue(fields()[8]);
        return record;
      } catch (Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }
}
