/*
 * Copyright 2014 CyberVision, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Autogenerated by Avro
 * 
 * DO NOT EDIT DIRECTLY
 */
package org.kaaproject.kaa.common.endpoint.gen;  
@SuppressWarnings("all")
@org.apache.avro.specific.AvroGenerated
public class SyncResponse extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"SyncResponse\",\"namespace\":\"org.kaaproject.kaa.common.endpoint.gen\",\"fields\":[{\"name\":\"appStateSeqNumber\",\"type\":\"int\"},{\"name\":\"responseType\",\"type\":{\"type\":\"enum\",\"name\":\"SyncResponseStatus\",\"symbols\":[\"NO_DELTA\",\"DELTA\",\"PROFILE_RESYNC\",\"CONF_RESYNC\",\"REDIRECT\"]}},{\"name\":\"confSyncResponse\",\"type\":[{\"type\":\"record\",\"name\":\"ConfSyncResponse\",\"fields\":[{\"name\":\"confSchemaBody\",\"type\":[\"bytes\",\"null\"]},{\"name\":\"confDeltaBody\",\"type\":[\"bytes\",\"null\"]}]},\"null\"]},{\"name\":\"notificationSyncResponse\",\"type\":[{\"type\":\"record\",\"name\":\"NotificationSyncResponse\",\"fields\":[{\"name\":\"notifications\",\"type\":[{\"type\":\"array\",\"items\":{\"type\":\"record\",\"name\":\"Notification\",\"fields\":[{\"name\":\"topicId\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"type\",\"type\":{\"type\":\"enum\",\"name\":\"NotificationType\",\"symbols\":[\"SYSTEM\",\"CUSTOM\"]}},{\"name\":\"uid\",\"type\":[{\"type\":\"string\",\"avro.java.string\":\"String\"},\"null\"]},{\"name\":\"seqNumber\",\"type\":[\"int\",\"null\"]},{\"name\":\"body\",\"type\":\"bytes\"}]}},\"null\"]},{\"name\":\"availableTopics\",\"type\":[{\"type\":\"array\",\"items\":{\"type\":\"record\",\"name\":\"Topic\",\"fields\":[{\"name\":\"id\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"name\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"subscriptionType\",\"type\":{\"type\":\"enum\",\"name\":\"SubscriptionType\",\"symbols\":[\"MANDATORY\",\"VOLUNTARY\"]}}]}},\"null\"]}]},\"null\"]},{\"name\":\"redirectSyncResponse\",\"type\":[{\"type\":\"record\",\"name\":\"RedirectSyncResponse\",\"fields\":[{\"name\":\"dnsName\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}}]},\"null\"]}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }
   private int appStateSeqNumber;
   private org.kaaproject.kaa.common.endpoint.gen.SyncResponseStatus responseType;
   private org.kaaproject.kaa.common.endpoint.gen.ConfSyncResponse confSyncResponse;
   private org.kaaproject.kaa.common.endpoint.gen.NotificationSyncResponse notificationSyncResponse;
   private org.kaaproject.kaa.common.endpoint.gen.RedirectSyncResponse redirectSyncResponse;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use {@link \#newBuilder()}. 
   */
  public SyncResponse() {}

  /**
   * All-args constructor.
   */
  public SyncResponse(java.lang.Integer appStateSeqNumber, org.kaaproject.kaa.common.endpoint.gen.SyncResponseStatus responseType, org.kaaproject.kaa.common.endpoint.gen.ConfSyncResponse confSyncResponse, org.kaaproject.kaa.common.endpoint.gen.NotificationSyncResponse notificationSyncResponse, org.kaaproject.kaa.common.endpoint.gen.RedirectSyncResponse redirectSyncResponse) {
    this.appStateSeqNumber = appStateSeqNumber;
    this.responseType = responseType;
    this.confSyncResponse = confSyncResponse;
    this.notificationSyncResponse = notificationSyncResponse;
    this.redirectSyncResponse = redirectSyncResponse;
  }

  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call. 
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return appStateSeqNumber;
    case 1: return responseType;
    case 2: return confSyncResponse;
    case 3: return notificationSyncResponse;
    case 4: return redirectSyncResponse;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }
  // Used by DatumReader.  Applications should not call. 
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: appStateSeqNumber = (java.lang.Integer)value$; break;
    case 1: responseType = (org.kaaproject.kaa.common.endpoint.gen.SyncResponseStatus)value$; break;
    case 2: confSyncResponse = (org.kaaproject.kaa.common.endpoint.gen.ConfSyncResponse)value$; break;
    case 3: notificationSyncResponse = (org.kaaproject.kaa.common.endpoint.gen.NotificationSyncResponse)value$; break;
    case 4: redirectSyncResponse = (org.kaaproject.kaa.common.endpoint.gen.RedirectSyncResponse)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'appStateSeqNumber' field.
   */
  public java.lang.Integer getAppStateSeqNumber() {
    return appStateSeqNumber;
  }

  /**
   * Sets the value of the 'appStateSeqNumber' field.
   * @param value the value to set.
   */
  public void setAppStateSeqNumber(java.lang.Integer value) {
    this.appStateSeqNumber = value;
  }

  /**
   * Gets the value of the 'responseType' field.
   */
  public org.kaaproject.kaa.common.endpoint.gen.SyncResponseStatus getResponseType() {
    return responseType;
  }

  /**
   * Sets the value of the 'responseType' field.
   * @param value the value to set.
   */
  public void setResponseType(org.kaaproject.kaa.common.endpoint.gen.SyncResponseStatus value) {
    this.responseType = value;
  }

  /**
   * Gets the value of the 'confSyncResponse' field.
   */
  public org.kaaproject.kaa.common.endpoint.gen.ConfSyncResponse getConfSyncResponse() {
    return confSyncResponse;
  }

  /**
   * Sets the value of the 'confSyncResponse' field.
   * @param value the value to set.
   */
  public void setConfSyncResponse(org.kaaproject.kaa.common.endpoint.gen.ConfSyncResponse value) {
    this.confSyncResponse = value;
  }

  /**
   * Gets the value of the 'notificationSyncResponse' field.
   */
  public org.kaaproject.kaa.common.endpoint.gen.NotificationSyncResponse getNotificationSyncResponse() {
    return notificationSyncResponse;
  }

  /**
   * Sets the value of the 'notificationSyncResponse' field.
   * @param value the value to set.
   */
  public void setNotificationSyncResponse(org.kaaproject.kaa.common.endpoint.gen.NotificationSyncResponse value) {
    this.notificationSyncResponse = value;
  }

  /**
   * Gets the value of the 'redirectSyncResponse' field.
   */
  public org.kaaproject.kaa.common.endpoint.gen.RedirectSyncResponse getRedirectSyncResponse() {
    return redirectSyncResponse;
  }

  /**
   * Sets the value of the 'redirectSyncResponse' field.
   * @param value the value to set.
   */
  public void setRedirectSyncResponse(org.kaaproject.kaa.common.endpoint.gen.RedirectSyncResponse value) {
    this.redirectSyncResponse = value;
  }

  /** Creates a new SyncResponse RecordBuilder */
  public static org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder newBuilder() {
    return new org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder();
  }
  
  /** Creates a new SyncResponse RecordBuilder by copying an existing Builder */
  public static org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder newBuilder(org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder other) {
    return new org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder(other);
  }
  
  /** Creates a new SyncResponse RecordBuilder by copying an existing SyncResponse instance */
  public static org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder newBuilder(org.kaaproject.kaa.common.endpoint.gen.SyncResponse other) {
    return new org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder(other);
  }
  
  /**
   * RecordBuilder for SyncResponse instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<SyncResponse>
    implements org.apache.avro.data.RecordBuilder<SyncResponse> {

    private int appStateSeqNumber;
    private org.kaaproject.kaa.common.endpoint.gen.SyncResponseStatus responseType;
    private org.kaaproject.kaa.common.endpoint.gen.ConfSyncResponse confSyncResponse;
    private org.kaaproject.kaa.common.endpoint.gen.NotificationSyncResponse notificationSyncResponse;
    private org.kaaproject.kaa.common.endpoint.gen.RedirectSyncResponse redirectSyncResponse;

    /** Creates a new Builder */
    private Builder() {
      super(org.kaaproject.kaa.common.endpoint.gen.SyncResponse.SCHEMA$);
    }
    
    /** Creates a Builder by copying an existing Builder */
    private Builder(org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.appStateSeqNumber)) {
        this.appStateSeqNumber = data().deepCopy(fields()[0].schema(), other.appStateSeqNumber);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.responseType)) {
        this.responseType = data().deepCopy(fields()[1].schema(), other.responseType);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.confSyncResponse)) {
        this.confSyncResponse = data().deepCopy(fields()[2].schema(), other.confSyncResponse);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.notificationSyncResponse)) {
        this.notificationSyncResponse = data().deepCopy(fields()[3].schema(), other.notificationSyncResponse);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.redirectSyncResponse)) {
        this.redirectSyncResponse = data().deepCopy(fields()[4].schema(), other.redirectSyncResponse);
        fieldSetFlags()[4] = true;
      }
    }
    
    /** Creates a Builder by copying an existing SyncResponse instance */
    private Builder(org.kaaproject.kaa.common.endpoint.gen.SyncResponse other) {
            super(org.kaaproject.kaa.common.endpoint.gen.SyncResponse.SCHEMA$);
      if (isValidValue(fields()[0], other.appStateSeqNumber)) {
        this.appStateSeqNumber = data().deepCopy(fields()[0].schema(), other.appStateSeqNumber);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.responseType)) {
        this.responseType = data().deepCopy(fields()[1].schema(), other.responseType);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.confSyncResponse)) {
        this.confSyncResponse = data().deepCopy(fields()[2].schema(), other.confSyncResponse);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.notificationSyncResponse)) {
        this.notificationSyncResponse = data().deepCopy(fields()[3].schema(), other.notificationSyncResponse);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.redirectSyncResponse)) {
        this.redirectSyncResponse = data().deepCopy(fields()[4].schema(), other.redirectSyncResponse);
        fieldSetFlags()[4] = true;
      }
    }

    /** Gets the value of the 'appStateSeqNumber' field */
    public java.lang.Integer getAppStateSeqNumber() {
      return appStateSeqNumber;
    }
    
    /** Sets the value of the 'appStateSeqNumber' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder setAppStateSeqNumber(int value) {
      validate(fields()[0], value);
      this.appStateSeqNumber = value;
      fieldSetFlags()[0] = true;
      return this; 
    }
    
    /** Checks whether the 'appStateSeqNumber' field has been set */
    public boolean hasAppStateSeqNumber() {
      return fieldSetFlags()[0];
    }
    
    /** Clears the value of the 'appStateSeqNumber' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder clearAppStateSeqNumber() {
      fieldSetFlags()[0] = false;
      return this;
    }

    /** Gets the value of the 'responseType' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponseStatus getResponseType() {
      return responseType;
    }
    
    /** Sets the value of the 'responseType' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder setResponseType(org.kaaproject.kaa.common.endpoint.gen.SyncResponseStatus value) {
      validate(fields()[1], value);
      this.responseType = value;
      fieldSetFlags()[1] = true;
      return this; 
    }
    
    /** Checks whether the 'responseType' field has been set */
    public boolean hasResponseType() {
      return fieldSetFlags()[1];
    }
    
    /** Clears the value of the 'responseType' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder clearResponseType() {
      responseType = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /** Gets the value of the 'confSyncResponse' field */
    public org.kaaproject.kaa.common.endpoint.gen.ConfSyncResponse getConfSyncResponse() {
      return confSyncResponse;
    }
    
    /** Sets the value of the 'confSyncResponse' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder setConfSyncResponse(org.kaaproject.kaa.common.endpoint.gen.ConfSyncResponse value) {
      validate(fields()[2], value);
      this.confSyncResponse = value;
      fieldSetFlags()[2] = true;
      return this; 
    }
    
    /** Checks whether the 'confSyncResponse' field has been set */
    public boolean hasConfSyncResponse() {
      return fieldSetFlags()[2];
    }
    
    /** Clears the value of the 'confSyncResponse' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder clearConfSyncResponse() {
      confSyncResponse = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /** Gets the value of the 'notificationSyncResponse' field */
    public org.kaaproject.kaa.common.endpoint.gen.NotificationSyncResponse getNotificationSyncResponse() {
      return notificationSyncResponse;
    }
    
    /** Sets the value of the 'notificationSyncResponse' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder setNotificationSyncResponse(org.kaaproject.kaa.common.endpoint.gen.NotificationSyncResponse value) {
      validate(fields()[3], value);
      this.notificationSyncResponse = value;
      fieldSetFlags()[3] = true;
      return this; 
    }
    
    /** Checks whether the 'notificationSyncResponse' field has been set */
    public boolean hasNotificationSyncResponse() {
      return fieldSetFlags()[3];
    }
    
    /** Clears the value of the 'notificationSyncResponse' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder clearNotificationSyncResponse() {
      notificationSyncResponse = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /** Gets the value of the 'redirectSyncResponse' field */
    public org.kaaproject.kaa.common.endpoint.gen.RedirectSyncResponse getRedirectSyncResponse() {
      return redirectSyncResponse;
    }
    
    /** Sets the value of the 'redirectSyncResponse' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder setRedirectSyncResponse(org.kaaproject.kaa.common.endpoint.gen.RedirectSyncResponse value) {
      validate(fields()[4], value);
      this.redirectSyncResponse = value;
      fieldSetFlags()[4] = true;
      return this; 
    }
    
    /** Checks whether the 'redirectSyncResponse' field has been set */
    public boolean hasRedirectSyncResponse() {
      return fieldSetFlags()[4];
    }
    
    /** Clears the value of the 'redirectSyncResponse' field */
    public org.kaaproject.kaa.common.endpoint.gen.SyncResponse.Builder clearRedirectSyncResponse() {
      redirectSyncResponse = null;
      fieldSetFlags()[4] = false;
      return this;
    }

    @Override
    public SyncResponse build() {
      try {
        SyncResponse record = new SyncResponse();
        record.appStateSeqNumber = fieldSetFlags()[0] ? this.appStateSeqNumber : (java.lang.Integer) defaultValue(fields()[0]);
        record.responseType = fieldSetFlags()[1] ? this.responseType : (org.kaaproject.kaa.common.endpoint.gen.SyncResponseStatus) defaultValue(fields()[1]);
        record.confSyncResponse = fieldSetFlags()[2] ? this.confSyncResponse : (org.kaaproject.kaa.common.endpoint.gen.ConfSyncResponse) defaultValue(fields()[2]);
        record.notificationSyncResponse = fieldSetFlags()[3] ? this.notificationSyncResponse : (org.kaaproject.kaa.common.endpoint.gen.NotificationSyncResponse) defaultValue(fields()[3]);
        record.redirectSyncResponse = fieldSetFlags()[4] ? this.redirectSyncResponse : (org.kaaproject.kaa.common.endpoint.gen.RedirectSyncResponse) defaultValue(fields()[4]);
        return record;
      } catch (Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }
}
